.\"=====================================================================
.\"  @Troff-man-file{
.\"     author          = "Nelson H. F. Beebe",
.\"     version         = "0.10",
.\"     date            = "12 October 1995",
.\"     time            = "15:23:30 MDT",
.\"     filename        = "htmlpty.man",
.\"     address         = "Center for Scientific Computing
.\"                        Department of Mathematics
.\"                        University of Utah
.\"                        Salt Lake City, UT 84112
.\"                        USA",
.\"     telephone       = "+1 801 581 5254",
.\"     FAX             = "+1 801 581 4148",
.\"     checksum        = "09362 1196 4719 26234",
.\"     email           = "beebe@math.utah.edu (Internet)",
.\"     codetable       = "ISO/ASCII",
.\"     keywords        = "HTML, prettyprinter, SGML, WWW, World-Wide Web",
.\"     supported       = "yes",
.\"     docstring       = "This file contains the UNIX manual pages
.\"                        for the html-pretty utility, a program for
.\"                        prettyprinting World-Wide Web HyperText
.\"                        Markup Language (HTML) files.
.\"
.\"                        The checksum field above contains a CRC-16
.\"                        checksum as the first value, followed by the
.\"                        equivalent of the standard UNIX wc (word
.\"                        count) utility output of lines, words, and
.\"                        characters.  This is produced by Robert
.\"                        Solovay's checksum utility.",
.\"  }
.\"=====================================================================
.TH HTML-PRETTY 1 "12 October 1995" "Version 0.10"
.\"=====================================================================
.\"
.if t .ds La L\\h'-0.24m'\\v'-0.15v'\\s-2A\\s+2\\h'-0.15m'\\v'0.15v'T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds La LaTeX
.\"
.if t .ds Te T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds Te TeX
.\"
.\"=====================================================================
.SH NAME
html-pretty \- prettyprint HTML files
.\"=====================================================================
.SH SYNOPSIS
.B html-pretty
[
.B \-?
]
[
.B \-a
]
[
.B \-c
]
[
.BI \-f " filename"
]
[
.B \-h
]
.if n .ti +9n
[
.BI \-i " nnn"
]
[
.B \-n
]
[
.B \-v
]
[
.BI \-w " nnn"
]
.if n .ti +9n
< infile > outfile
.nf
or
.fi
.B html-pretty
[
.B \-?
]
[
.B \-a
]
[
.B \-c
]
[
.BI \-f " filename"
]
[
.B \-h
]
.if n .ti +9n
[
.BI \-i " nnn"
]
[
.B \-n
]
[
.B \-v
]
[
.BI \-w " nnn"
]
.if n .ti +9n
file(s)
> outfile
.\"=====================================================================
.SH DESCRIPTION
.PP
.B html-pretty
filters its HTML input from
.IR stdin ,
or from one or more named files given on the command line, and
prettyprints it to
.IR stdout .
.PP
HTML (HyperText Markup Language) is the language used to specify
formatting instructions in text files intended for viewing with
World-Wide Web (WWW) client programs (browsers), such as
.BR arena (1),
.BR hotjava (1),
.BR lynx (1),
.BR netscape (1),
and
.BR xmosaic (1).
.PP
The WWW idea began in late 1992, and because viewer programs support
display of text, line drawings, color raster images, hypertext links,
and uniform access to several Internet services, including file
transfer, in the first two years, the number of WWW servers grew from
zero to several hundred thousand, and some of the more popular sites
receive up to two million accesses a day from all over the Internet.
Consequently, many Internet computer users are beginning to write HTML
documents for their own home pages, and
.B html-pretty
is written for them.
.PP
The goal of a prettyprinter is to recognize all legal inputs, and
produce output that is indented to reflect the structure, and in which
line lengths have been restricted for improved readability.
Irregularities in coding practice, and outright errors, are more likely
to be detected in the prettyprinted output, than in the input.
.PP
SGML (Standard General Markup Language, ISO8879), and its particular
document type definition instance, HTML, follow a rigorous grammar for
text markup that makes it possible to clearly identify document parts,
such as headings, sections, subsections, paragraphs, figures, tables,
equations, and so on, and files with such standardized markup are
particularly good candidates for prettyprinting.
.PP
The current definition of HTML is still in flux (version 2.0 is
nearing standardization, and version 3.0, informally called HTML Plus,
is under development in early 1995).
.B html-pretty
follows the grammar of version 3.0, which is a superset of that of
version 2.0.  Version 3.0 introduces several new tags (see the
.B "FORMATTING CONVENTIONS"
section below), and supports figures, input forms, tables, and a
limited math mode.
.PP
One significant difference between the two grammar versions is that
the HTML tag
.I <P>
is a paragraph
.I separator
in version 2.0, while it is a paragraph
.I begin
in version 3.0, and consequently expects to have a matching
.I </P>
end tag that is not required in 2.0.
.B html-pretty
will supply missing
.I </P>
tags, and delete empty
.I "<P> .\|.\|. </P>"
environments.  Since HTML translators ignore unrecognized tags, this
is transparent to HTML version 2.0 implementations, and causes no
problems.
.PP
.B html-pretty
expects that its input is reasonably well-formed. Usually it is
sufficient that the file can be displayed by one or more WWW browsers,
producing the expected form.  However, it would be unwise to write a
large amount of program code without a compiler to check it, and it is
similarly unwise to write documentation in HTML or SGML without at
least a validating parser to ensure that the text is syntactically
correct.
.PP
Fortunately, at least two such programs are publicly available (thanks
to the generosity of their author, James Clark)
.BR nsgmls (1)
and
.BR sgmls (1),
together with UNIX shell scripts,
.BR html-check (1)
and
.BR html-ncheck (1),
to facilitate their use with HTML files.  In addition, the
.BR nsgmls (1)
distribution is accompanied by two SGML tag normalizers,
.BR sgmlnorm (1)
and
.BR spam (1),
and there is a UNIX shell script,
.BR html-spam (1),
for one of them.  You may therefore find it useful to apply
.BR html-spam (1),
and either
.BR html-check (1)
or
.BR html-ncheck (1),
to your HTML files, and fix all of the errors that they detect, before
filtering the files with
.BR html-pretty .
.PP
HTML strictly requires a certain amount of
.I boiler-plate
to be wrapped around the text, and there is ample evidence that most
HTML files omit these wrappers, because WWW browsers are written to be
tolerant of grammatical deviations.
.B html-pretty
will supply the wrappers if they are omitted; indeed, if given an
empty input file,
.B html-pretty
produces output similar to this:
.nf
<!-- -*-html-*- -->
<!-- Prettyprinted by html-pretty lex version 0.09 [05-May-1995] -->
<!-- on Sat May  6 09:55:25 1995 -->
<!-- for Nelson H. F. Beebe (beebe@sunrise) -->

<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">

<HTML>
    <HEAD>
        <TITLE>
            <!-- Please supply a descriptive title here -->
        </TITLE>
        <!-- Please supply a correct e-mail address here -->
        <LINK REV="made" HREF="mailto:USERNAME@HOSTNAME>">
    </HEAD>
    <BODY>
    </BODY>
</HTML>
.fi
This example, minus the comments
.IR "<!-- .\|.\|. -->" ,
shows the minimal markup that should be expected in an HTML file,
although the grammar permits the HTML, HEAD and BODY environments to
be implicitly assumed if they are omitted.  While WWW browsers ignore
the DOCTYPE declaration, it is essential for SGML parsers, since it
identifies the grammar rules that apply to what follows.
.\"=====================================================================
.SH OPTIONS
The following command-line options are supported, and they affect all
following filenames.  Option values are always provided as separate
arguments following the option name.  Letter case in option names is
.I not
significant.
.PP
Any argument that begins with a hyphen is expected to be an option,
and will raise an error if it is not recognized.  If a filename begins
with a hyphen, you therefore need to disguise it by supplying a
leading directory path.  For example,
.IR ./\-foo
represents the file named
.I \-foo
in the current directory in UNIX.
.PP
.\"---------------------------------------------------------------------
.TP \w'\-f\ \fIfilename\fP'u+3n
.B \-a
Show author information on
.IR stderr .
.\"---------------------------------------------------------------------
.TP
.B \-c
Show copyright information on
.IR stderr .
.\"---------------------------------------------------------------------
.TP
.BI \-f " filename"
Supply an alternate input filename for use in the output comment
banner.  This overrides the actual filename(s), and provides a way to
name the output, even when no named input file is available, because
standard input is redirected, or comes from a pipe.
.\"---------------------------------------------------------------------
.TP
.BR \-h " or " \-?
Display brief usage information on
.IR stderr .
.\"---------------------------------------------------------------------
.TP
.BI \-i " nnn"
Set the number of spaces for each indentation level (default: 4).
.\"---------------------------------------------------------------------
.TP
.B \-n
Suppress generation of the default leading comment banner.
.\"---------------------------------------------------------------------
.TP
.B \-v
Show version information on
.IR stderr .
.\"---------------------------------------------------------------------
.TP
.BI \-w " nnn"
Set the maximum output line width (default: 72).  This limit may be
exceeded if an excessively long string without embedded spaces is
encountered, and it is ignored completely inside preformatted or
verbatim text.
.\"=====================================================================
.SH "FORMATTING CONVENTIONS"
HTML 2.0 contains the following 49 tags:
.IR A ,
.IR ADDRESS ,
.IR B ,
.IR BASE ,
.IR BLOCKQUOTE ,
.IR BODY ,
.IR BR ,
.IR CITE ,
.IR CODE ,
.IR DD ,
.IR DIR ,
.IR DL ,
.IR DT ,
.IR EM ,
.IR FORM ,
.IR H1 ,
.IR H2 ,
.IR H3 ,
.IR H4 ,
.IR H5 ,
.IR H6 ,
.IR HEAD ,
.IR HR ,
.IR HTML ,
.IR I ,
.IR IMG ,
.IR INPUT ,
.IR ISINDEX ,
.IR KBD ,
.IR LI ,
.IR LINK ,
.IR LISTING ,
.IR MENU ,
.IR META ,
.IR NEXTID ,
.IR OL ,
.IR OPTION ,
.IR P ,
.IR PLAINTEXT ,
.IR PRE ,
.IR SAMP ,
.IR SELECT ,
.IR STRONG ,
.IR TEXTAREA ,
.IR TITLE ,
.IR TT ,
.IR UL ,
.IR VAR ,
and
.IR XMP .
.PP
HTML 3.0 augments the 2.0 grammar with 53 additional tags:
.IR ABBREV ,
.IR ABOVE ,
.IR ACRONYM ,
.IR ARRAY ,
.IR ATOP ,
.IR AU ,
.IR BAR ,
.IR BELOW ,
.IR BIG ,
.IR BOX ,
.IR BQ ,
.IR BT ,
.IR CAPTION ,
.IR CHOOSE ,
.IR CREDIT ,
.IR DDOT ,
.IR DEL ,
.IR DFN ,
.IR DIV ,
.IR DOT ,
.IR FIG ,
.IR HAT ,
.IR INS ,
.IR ITEM ,
.IR LANG ,
.IR LEFT ,
.IR LH ,
.IR MATH ,
.IR NOTE ,
.IR OF ,
.IR OVER ,
.IR OVERLAY ,
.IR PERSON ,
.IR PRE ,
.IR Q ,
.IR RIGHT ,
.IR ROOT ,
.IR ROW ,
.IR S ,
.IR SMALL ,
.IR SQRT ,
.IR STYLE ,
.IR SUB ,
.IR SUP ,
.IR T ,
.IR TAB ,
.IR TABLE ,
.IR TD ,
.IR TH ,
.IR TILDE ,
.IR TR ,
.IR U ,
and
.IR VEC .
.PP
These tags are identified by their occurrence in the
.I html.dtd
and
.I html-3.dtd
document type definition files in lines like these:
.RS
.nf
<!ENTITY % font " TT | B | I ">
<!ENTITY % phrase "EM | STRONG | CODE | SAMP | KBD | VAR | CITE ">
<!ELEMENT (%font;|%phrase) - - (%text)+>
<!ELEMENT XMP - -  %literal>
.fi
.RE
ENTITY declarations define text string substitutions, and ELEMENT
declarations define the tags recognized by the grammar.
.PP
The HTML grammar permits certain end tags to be omitted, when their
implied position can be determined from the grammatical context.  In
HTML 3.0, this includes the following tags:
.IR BODY ,
.IR DD ,
.IR DT ,
.IR HEAD ,
.IR ITEM ,
.IR LI ,
.IR MESSAGE ,
.IR OPTION ,
.IR P ,
.IR TD ,
.IR TH ,
and
.IR TR .
Supporting such a feature requires the ability to parse a complete
SGML grammar, which requires a great deal more code than
.B html-pretty
provides.  Consequently, it does not support optional end tags; based
on typical usage, they are expected to be always present, or always
absent, according to the rules given below.
.PP
HTML comments are prettyprinted on separate lines at the current
indentation level.
.PP
The following HTML tag names occur in begin/end pairs
.RI ( <TAG> and </TAG> ),
often with substantial amounts of intervening text.  They are
prettyprinted on separate lines, with their enclosed text indented one
level:
.IR A ,
.IR ABBREV ,
.IR ABSTRACT ,
.IR ACRONYM ,
.IR ADDED ,
.IR ADDRESS ,
.IR ARG ,
.IR AROW ,
.IR ARRAY ,
.IR AU ,
.IR BLOCKQUOTE ,
.IR BODY ,
.IR BQ ,
.IR CAPTION ,
.IR CITE ,
.IR CMD ,
.IR CREDIT ,
.IR DIV1 ,
.IR DIV2 ,
.IR DIV3 ,
.IR DIV4 ,
.IR DIV5 ,
.IR DIV6 ,
.IR FIG ,
.IR FN ,
.IR FOOTNOTE ,
.IR FORM ,
.IR H1 ,
.IR H2 ,
.IR H3 ,
.IR H4 ,
.IR H5 ,
.IR H6 ,
.IR HEAD ,
.IR HIDE ,
.IR HTML ,
.IR LANG ,
.IR LH ,
.IR MARGIN ,
.IR MATH ,
.IR MESSAGE ,
.IR NOTE ,
.IR OPTION ,
.IR OVERLAY ,
.IR P ,
.IR PERSON ,
.IR Q ,
.IR QUOTE ,
.IR REMOVED ,
.IR SELECT ,
.IR TABLE ,
.IR TEXTAREA ,
and
.IR TITLE .
.PP
These HTML tag names occur in begin/end pairs, usually with smaller
amounts of enclosed material.  They appear inline in the running text,
and do not alter indentation:
.IR B ,
.IR BIG ,
.IR BT ,
.IR CODE ,
.IR DFN ,
.IR EM ,
.IR I ,
.IR KBD ,
.IR Q ,
.IR REV ,
.IR S ,
.IR SAMP ,
.IR SMALL ,
.IR STRONG ,
.IR T ,
.IR TT ,
.IR U ,
and
.IR VAR .
.PP
These HTML tags names occur in begin/end pairs, and delimit lists.
They appear on separate lines, with their enclosed text indented two
levels:
.IR DIR ,
.IR DL ,
.IR MENU ,
.IR OL ,
and
.IR UL .
.PP
These HTML tags mark the beginning of list items, and have matching
end tags which are supplied if they are absent.  They are output on
separate lines, indented one level from the enclosing list:
.IR DD ,
.IR DT ,
and
.IR LI .
.PP
These HTML tag names appear inline, without affecting indentation:
.IR TAB ,
.IR TAG ,
.IR TD ,
.IR TH ,
and
.IR TR .
.PP
These HTML tag names occur only inside
.IR MATH
mode, and appear inline, without affecting indentation:
.IR ABOVE ,
.IR ATOP ,
.IR BAR ,
.IR BELOW ,
.IR BOX ,
.IR CHOOSE ,
.IR DDOT ,
.IR DEL ,
.IR DOT ,
.IR HAT ,
.IR INS ,
.IR LEFT ,
.IR OF ,
.IR RIGHT ,
.IR ROOT ,
.IR ROW ,
.IR SQRT ,
.IR SUB ,
.IR SUP ,
.IR TILDE ,
and
.IR VEC .
.PP
This HTML tag marks an explicit line break, and has no matching end
tag; preceding space is deleted, and a newline follows:
.IR BR .
.PP
These HTML tags have no matching end tag; they appear alone on
separate lines:
.IR BASE ,
.IR CHANGED ,
.IR HR ,
.IR IMG ,
.IR ITEM ,
.IR INPUT ,
.IR ISINDEX ,
.IR LINK ,
.IR META ,
.IR NEXTID ,
.IR OVER ,
.IR RENDER ,
.IR STYLE ,
and
.IR STYLES .
.PP
These HTML tags appear in begin/end pairs, and delimit preformatted,
or verbatim text.  The beginning and ending tags are output on
separate lines, with the enclosed material copied exactly as it
appeared in the input stream:
.IR CDATA ,
.IR LISTING ,
.IR PRE ,
and
.IR XMP .
.PP
Finally, the HTML tag
.I PLAINTEXT
marks the beginning of verbatim text that continues to end-of-file; it
appears on a separate line.  Although some HTML viewers will terminate
the verbatim text environment on reaching a matching end tag,
.IR </PLAINTEXT> ,
that practice is now considered erroneous.
.PP
All tags that are not explicitly named above are treated as normal
text, and have no effect on the indentation.
.\"=====================================================================
.SH "LIMITATIONS"
Like \*(La\&, Lisp, and \*(Te\&, SGML is an
.I extensible
language.  In particular, it is possible to redefine at run time the
syntax and semantics of all lexical elements, including the base
character set, the characters that may appear in identifiers, and the
special characters that delimit tags or strings.
.PP
In SGML, this is conventionally done in SGML declaration files for
syntax definitions, and in Document Type Definition (DTD) files, which
are analogous to \*(La\& style files.  Low-level typesetting commands
of the flavor ``select a 14-point Lucida-BoldItalic font'', ``skip
down vertically 6 picas'', and ``draw a horizontal rule 3 ems long''
are notably absent.  SGML documents are expected to use only
high-level markup commands, leaving the visual appearance entirely up
to the DTD specification, and the formatting software.
.PP
Unlike \*(La\& and \*(Te\&, SGML is
.I not
a typesetting system.  It is only a grammar for a standard markup
language, and it is left to SGML software implementors to write DTDs,
and to provide for translation of SGML documents to specific document
formatting, typesetting, or word processing systems.  In this respect,
SGML is similar to the RTF (Rich Text Format) supported by many
popular word processors, in that it can serve as an intermediate
language for electronic document exchange; several language
translators between SGML and other text representations are mentioned
in the
.B "SEE ALSO"
section below.  Regrettably, there is wide variation in the
capabilities and document models of current text formatting systems,
so such translations are usually rough approximations that may require
substantial hand patching to make them truly satisfactory.
.PP
HTML is a modest subset of SGML, with tag names apparently chosen from
SGML, the Free Software Foundation's \*(Te\&info system (which in turn
is modeled on the earlier Scribe document formatting system), and
occasionally, also from \*(La\&.
.PP
.B html-pretty
is written in this spirit: it knows about the meaning and typical use
of all standard HTML tags, but nothing about other SGML DTDs.  While
it would be reasonably straightforward to prepare modifications of
.B html-pretty
to support other, specific, SGML DTDs, you cannot expect it to
be very effective for handling arbitrary SGML text.
.\"=====================================================================
.SH "HTML 2.0 CONSTRAINTS"
It is not immediately obvious from the HTML grammar just what tags can
be contained in, or by, other tags.  The following list, adapted from
the Soft Quad
.I HoTMetaL
documentation, provides a useful summary.  HTML tags that are obsolete
in the HTML 2.0 grammar are identified; they should not be used in new
documents.
.br
.B "A"
.RS
.I "contained in:"
ADDRESS B BODY CITE CODE DD DFN DT EM H1 H2 H3 H4 H5 H6 I KBD LI P PRE
SAMP STRONG TT U VAR
.RE
.RS
.I "contains:"
#PCDATA B CITE CODE DFN EM I IMG KBD SAMP STRONG TT U VAR
.RE
.B "ADDRESS"
.RS
.I "contained in:"
BLOCKQUOTE BODY FORM LI
.RE
.RS
.I "contains:"
#PCDATA A HR IMG P
.RE
.B "B"
.RS
.I "contained in:"
A B CITE CODE DD DFN DT EM H1 H2 H3 H4 H5 H6 I KBD KEY LI P PRE SAMP
STRONG TT U VAR
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN EM I IMG INPUT KBD SAMP STRONG TEXTAREA
TT U VAR
.RE
.B "BASE"
.RS
.I "contained in:"
HEAD
.RE
.B "BLOCKQUOTE"
(obsolete)
.RS
.I "contained in:"
BODY FORM
.RE
.RS
.I "contains:"
#PCDATA ADDRESS DL HR IMG OL P PRE UL
.RE
.B "BODY"
.RS
.I "contained in:"
HTML
.RE
.RS
.I "contains:"
ADDRESS BLOCKQUOTE DL FORM H1 H2 H3 H4 H5 H6 HR IMG LISTING OL P PRE
UL XMP
.RE
.B "BR"
.RS
.I "contained in:"
A ADDRESS B BLOCKQUOTE CITE CODE DD DFN DT EM H1 H2 H3 H4 H5 H6 I KBD
P PRE SAMP STRONG TT U VAR
.RE
.B "CITE"
.RS
.I "contained in:"
A B CITE CODE DD DFN DT EM H1 H2 H3 H4 H5 H6 I KBD KEY LI P PRE SAMP
STRONG TT U VAR
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN EM I IMG INPUT KBD SAMP STRONG TEXTAREA
TT U VAR
.RE
.B "CODE"
.RS
.I "contained in:"
A B CITE CODE DD DFN DT EM H1 H2 H3 H4 H5 H6 I KBD KEY LI P PRE SAMP
STRONG TT U VAR
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN EM I IMG INPUT KBD SAMP STRONG TEXTAREA
TT U VAR
.RE
.B "DD"
.RS
.I "contained in:"
DL
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN DL EM HR I IMG INPUT KBD OL P PRE SAMP
STRONG TEXTAREA TT U UL VAR
.RE
.B "DFN"
.RS
.I "contained in:"
A B CITE CODE DD DFN DT EM H1 H2 H3 H4 H5 H6 I KBD KEY LI P PRE SAMP
STRONG TT U VAR
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN EM I IMG INPUT KBD SAMP STRONG TEXTAREA
TT U VAR
.RE
.B "DIR"
(obsolete)
.RS
.I "contains:"
LI
.RE
.B "DL"
.RS
.I "contained in:"
BLOCKQUOTE BODY DD FORM LI
.RE
.RS
.I "contains:"
DD DT
.RE
.B "DT"
.RS
.I "contained in:"
DL
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN EM I IMG INPUT KBD SAMP STRONG TEXTAREA
TT U VAR
.RE
.B "EM"
.RS
.I "contained in:"
A B CITE CODE DD DFN DT EM H1 H2 H3 H4 H5 H6 I KBD KEY LI P PRE SAMP
STRONG TT U VAR
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN EM I IMG INPUT KBD SAMP STRONG TEXTAREA
TT U VAR
.RE
.B "FORM"
.RS
.I "contained in:"
BODY FORM LI
.RE
.RS
.I "contains:"
ADDRESS BLOCKQUOTE DL FORM H1 H2 H3 H4 H5 H6 HR LISTING MESSAGE OL P
PRE UL XMP
.RE
.B "H1"
.RS
.I "contained in:"
BODY FORM
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN EM I IMG INPUT KBD SAMP STRONG TEXTAREA
TT U VAR
.RE
.B "H2"
.RS
.I "contained in:"
BODY FORM
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN EM I IMG INPUT KBD SAMP STRONG TEXTAREA
TT U VAR
.RE
.B "H3"
.RS
.I "contained in:"
BODY FORM
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN EM I IMG INPUT KBD SAMP STRONG TEXTAREA
TT U VAR
.RE
.B "H4"
.RS
.I "contained in:"
BODY FORM
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN EM I IMG INPUT KBD SAMP STRONG TEXTAREA
TT U VAR
.RE
.B "H5"
.RS
.I "contained in:"
BODY FORM
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN EM I IMG INPUT KBD SAMP STRONG TEXTAREA
TT U VAR
.RE
.B "H6"
.RS
.I "contained in:"
BODY FORM
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN EM I IMG INPUT KBD SAMP STRONG TEXTAREA
TT U VAR
.RE
.B "HEAD"
.RS
.I "contained in:"
HTML
.RE
.RS
.I "contains:"
BASE ISINDEX LINK META TITLE
.RE
.B "HR"
.RS
.I "contained in:"
ADDRESS BLOCKQUOTE BODY DD FORM LI
.RE
.B "HTML"
.RS
.I "contains:"
BODY HEAD
.RE
.B "I"
.RS
.I "contained in:"
A B CITE CODE DD DFN DT EM H1 H2 H3 H4 H5 H6 I KBD KEY LI P PRE SAMP
STRONG TT U VAR
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN EM I IMG INPUT KBD SAMP STRONG TEXTAREA
TT U VAR
.RE
.B "IMG"
.RS
.I "contained in:"
A ADDRESS B BLOCKQUOTE BODY CITE CODE DD DFN DT EM FORM H1 H2 H3 H4 H5
H6 I KBD LI P PRE SAMP
STRONG TT U VAR
.RE
.B "INPUT"
.RS
.I "contained in:"
B CITE CODE DD DFN DT EM H1 H2 H3 H4 H5 H6 I KBD P PRE SAMP STRONG TT
U VAR
.RE
.B "ISINDEX"
.RS
.I "contained in:"
HEAD
.RE
.B "KBD"
.RS
.I "contained in:"
A B CITE CODE DD DFN DT EM H1 H2 H3 H4 H5 H6 I KBD KEY LI P PRE SAMP
STRONG TT U VAR
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN EM I IMG INPUT KBD SAMP STRONG TEXTAREA
TT U VAR
.RE
.B "KEY"
(obsolete)
.RS
.I "contains:"
#PCDATA B CITE CODE DFN EM I KBD STRONG TT U VAR
.RE
.B "LI"
.RS
.I "contained in:"
DIR MENU OL UL
.RE
.RS
.I "contains:"
#PCDATA A ADDRESS B CITE CODE DFN DL EM FORM HR I IMG KBD OL P PRE
STRONG TT U UL VAR XMP
.RE
.B "LINK"
.RS
.I "contained in:"
HEAD
.RE
.B "LISTING"
.RS
.I "contained in:"
BODY FORM
.RE
.RS
.I "contains:"
12 A
.RE
.B "MENU"
(obsolete)
.RS
.I "contains:"
LI
.RE
.B "MESSAGE"
.RS
.I "contained in:"
FORM
.RE
.B "META"
.RS
.I "contained in:"
HEAD
.RE
.B "NEXTID"
(obsolete)
.br
.B "OL"
.RS
.I "contained in:"
BLOCKQUOTE BODY DD FORM LI
.RE
.RS
.I "contains:"
LI
.RE
.B "OPTION"
.RS
.I "contained in:"
SELECT
.RE
.B "P"
.RS
.I "contained in:"
ADDRESS BLOCKQUOTE BODY DD FORM LI
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN EM I IMG INPUT KBD SAMP STRONG TEXTAREA
TT U VAR
.RE
.B "PLAINTEXT"
(obsolete)
.br
.B "PRE"
.RS
.I "contained in:"
BLOCKQUOTE BODY DD FORM LI
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN EM I IMG INPUT KBD SAMP STRONG TEXTAREA
TT U VAR
.RE
.B "SAMP"
.RS
.I "contained in:"
A B CITE CODE DD DFN DT EM H1 H2 H3 H4 H5 H6 I KBD KEY LI P PRE SAMP
STRONG TT U VAR
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN EM I IMG INPUT KBD SAMP STRONG TEXTAREA
TT U VAR
.RE
.B "SELECT"
.RS
.I "contained in:"
B CITE CODE DD DFN DT EM H1 H2 H3 H4 H5 H6 I KBD P PRE SAMP STRONG TT
U VAR
.RE
.RS
.I "contains:"
OPTION
.RE
.B "STRONG"
.RS
.I "contained in:"
A B CITE CODE DD DFN DT EM H1 H2 H3 H4 H5 H6 I KBD KEY LI P PRE SAMP
STRONG TT U VAR
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN EM I IMG INPUT KBD SAMP STRONG
TEXTAREA TT U VAR
.RE
.B "TEXTAREA"
.RS
.I "contained in:"
B CITE CODE DD DFN DT EM H1 H2 H3 H4 H5 H6 I KBD P PRE SAMP STRONG TT
U VAR
.RE
.B "TITLE"
.RS
.I "contained in:"
HEAD
.RE
.RS
.I "contains:"
#PCDATA
.RE
.B "TT"
.RS
.I "contained in:"
A B CITE CODE DD DFN DT EM H1 H2 H3 H4 H5 H6 I KBD KEY LI P PRE SAMP
STRONG TT U VAR
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN EM I IMG INPUT KBD SAMP STRONG TEXTAREA
TT U VAR
.RE
.B "U"
.RS
.I "contained in:"
A B CITE CODE DD DFN DT EM H1 H2 H3 H4 H5 H6 I KBD KEY LI P PRE SAMP
STRONG TT U VAR
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN EM I IMG INPUT KBD SAMP STRONG TEXTAREA
TT U VAR
.RE
.B "UL"
.RS
.I "contained in:"
BLOCKQUOTE BODY DD FORM LI
.RE
.RS
.I "contains:"
LI
.RE
.B "VAR"
.RS
.I "contained in:"
A B CITE CODE DD DFN DT EM H1 H2 H3 H4 H5 H6 I KBD KEY LI P PRE SAMP
STRONG TT U VAR
.RE
.RS
.I "contains:"
#PCDATA A B BR CITE CODE DFN EM I IMG INPUT KBD SAMP STRONG
TEXTAREA TT U VAR
.RE
.B "XMP"
.RS
.I "contained in:"
BODY DD FORM LI
.RE
.\"=====================================================================
.SH "SEE ALSO"
.BR arena (1),
.BR hotjava (1),
.BR html (1),
.BR html2latex (1),
.BR html-check (1),
.BR html-ncheck (1),
.BR html-spam (1),
.BR latex (1),
.BR latex2html (1),
.BR latex2rtf (1),
.BR lisp (1),
.BR lynx (1),
.BR netscape (1),
.BR nsgmls (1),
.BR rtf2LaTeX (1),
.BR rtf2html (1),
.BR rtf2tex (1),
.BR rtflatex (1),
.BR scribe (1),
.BR sgml (1),
.BR sgmlnorm (1),
.BR sgmls (1),
.BR spam (1),
.BR tex (1),
.BR texi2html (1),
.BR texi2roff (1),
.BR texinfo (1),
.BR xmosaic (1).
.\"=====================================================================
.SH AUTHOR
.nf
Nelson H. F. Beebe, Ph.D.
Center for Scientific Computing
Department of Mathematics
University of Utah
Salt Lake City, UT 84112
Tel: +1 801 581 5254
FAX: +1 801 581 4148
Email: <beebe@math.utah.edu>
URL: http://www.math.utah.edu/~beebe
.fi
.\"==============================[The End]==============================
